/**
 * Copyright 2011 Nikolche Mihajlovski
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jannocessor.model.executable;

import org.jannocessor.annotation.Calculated;
import org.jannocessor.annotation.DomainModel;
import org.jannocessor.collection.api.PowerList;
import org.jannocessor.model.modifier.MethodModifiers;
import org.jannocessor.model.structure.JavaMetadata;
import org.jannocessor.model.structure.JavaTypeParameter;
import org.jannocessor.model.type.JavaType;
import org.jannocessor.model.variable.JavaParameter;

@DomainModel
public interface JavaMethod extends AbstractJavaExecutable {

	@Override
	@Calculated
	JavaMethod copy();

	PowerList<JavaTypeParameter> getTypeParameters();

	JavaType getReturnType();

	PowerList<JavaParameter> getParameters();

	Boolean isVarArgs();

	PowerList<JavaType> getThrownTypes();

	MethodModifiers getModifiers();

	PowerList<JavaMetadata> getMetadata();

}
